﻿'um Kleidungsstücke "auf die Reihe zu kriegen" bastel ich eine Baum-Struktur
Public Class Tree(Of T) : Inherits List(Of Tree(Of T))
   Public Value As T
   Public Sub New(ByVal Value As T)
      Me.Value = Value
   End Sub
End Class

Public Module Helpers
   'Generische Funktionen zur vereinfachten Erzeugung initialisierter Objekte

   Public Function KeyValue(Of TKey, TValue)(ByVal Key As TKey, ByVal Value As TValue) _
           As KeyValuePair(Of TKey, TValue)
      Return New KeyValuePair(Of TKey, TValue)(Key, Value)
   End Function

   Public Function NewArray(Of T)(ByVal ParamArray Args As T()) As T()
      Return Args
   End Function

   'Hiermit kann ein Dictionary erstellt werden mit anonym typisierten Values!!
   Public Function NewDictionary(Of T, T2)(ByVal Entries As IEnumerable(Of KeyValuePair(Of T, T2))) As Dictionary(Of T, T2)
      NewDictionary = New Dictionary(Of T, T2)
      For Each Itm In Entries
         NewDictionary.Add(Itm.Key, Itm.Value)
      Next
   End Function

End Module